Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.425
diff -u -r1.425 chan_zap.c
--- channels/chan_zap.c	5 Apr 2005 20:23:26 -0000	1.425
+++ channels/chan_zap.c	6 Apr 2005 19:30:06 -0000
@@ -7920,11 +7920,14 @@
 						if (e->ring.complete || !pri->overlapdial) {
 							/* Just announce proceeding */
 							pri_proceeding(pri->pri, e->ring.call, PVT_TO_CHANNEL(pri->pvts[chanpos]), 0);
+							pri->pvts[chanpos]->proceeding = 2;
 						} else  {
 							if (pri->switchtype != PRI_SWITCH_GR303_TMC) 
 								pri_need_more_info(pri->pri, e->ring.call, PVT_TO_CHANNEL(pri->pvts[chanpos]), 1);
-							else
+							else {
 								pri_answer(pri->pri, e->ring.call, PVT_TO_CHANNEL(pri->pvts[chanpos]), 1);
+								pri->pvts[chanpos]->proceeding = 2;
+							}
 						}
 						/* Get the use_callingpres state */
 						pri->pvts[chanpos]->callingpres = e->ring.callingpres;
@@ -8049,7 +8052,7 @@
 						chanpos = -1;
 					} else {
 						ast_mutex_lock(&pri->pvts[chanpos]->lock);
-						if (ast_strlen_zero(pri->pvts[chanpos]->dop.dialstr)) {
+						if ((pri->proceeding == 2) || ast_strlen_zero(pri->pvts[chanpos]->dop.dialstr)) {
 							zt_enable_ec(pri->pvts[chanpos]);
 							pri->pvts[chanpos]->subs[SUB_REAL].needringing =1;
 							pri->pvts[chanpos]->proceeding=2;
